//+------------------------------------------------------------------+
//|                                   cocktail_of_currency_pairs.mq4 |
//|                                     Copyright 2013, Festival MT4 |
//|                                                     Festival MT4 |
//|               |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Festival MT4"
#property link      "Festival MT4"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_width1 1
//----
extern string CURRENCY = "USD";
//+------------------------------------------------------------------+
double ExtBuffer1[];
//+------------------------------------------------------------------+
string CUR_SYMBOLS[];
int    COUNT_SYMBOLS;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   COUNT_SYMBOLS = 0;
   ArrayResize(CUR_SYMBOLS, COUNT_SYMBOLS);
   //----
   string cur_symbols[];
   int    count_symbols = SymbolsTerminal(cur_symbols);
   //----
   for (int i = 0; i < count_symbols; i++)
   {
      if (StringLen(cur_symbols[i]) > 6) continue;
      if (StringSubstr(cur_symbols[i], 0, 3) == CURRENCY)
      {
         COUNT_SYMBOLS++;
         ArrayResize(CUR_SYMBOLS, COUNT_SYMBOLS);
         CUR_SYMBOLS[COUNT_SYMBOLS - 1] = cur_symbols[i];
      }
      else
      if (StringSubstr(cur_symbols[i], 3, 3) == CURRENCY)
      {
         COUNT_SYMBOLS++;
         ArrayResize(CUR_SYMBOLS, COUNT_SYMBOLS);
         CUR_SYMBOLS[COUNT_SYMBOLS - 1] = cur_symbols[i];
      }
   }
   //----
   if (COUNT_SYMBOLS < 1)
   {
      Alert("<" + CURRENCY + ">    \n    USD");
      CURRENCY = "USD";
      init();
   }
   //----
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ExtBuffer1);
   IndicatorShortName("CoCP " + CURRENCY + " " + COUNT_SYMBOLS + ":");
   SetIndexLabel(0, "CoCP");
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted(),
       limit = Bars - counted_bars - 1,
       bars, count;
   double price, sum_price, var_close;
   //----
   for (bars = limit; bars >= 0; bars--)
   {
      sum_price = 0;
      for (count = 0; count < COUNT_SYMBOLS; count++)
      {
         price = iClose(CUR_SYMBOLS[count], 0, bars);
         if (StringSubstr(CUR_SYMBOLS[count], 3, 3) == CURRENCY)
         {
            var_close = iClose(CUR_SYMBOLS[count], 0, bars);
            price = var_close;
            if (var_close > 0) price = 1 / var_close;
         }
         sum_price += price;
      }
      ExtBuffer1[bars] = sum_price / COUNT_SYMBOLS;
   }
   //----
   return(0);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
int SymbolsTerminal(string &sSymbols[])
{
   int handle = FileOpenHistory("symbols.raw", FILE_BIN|FILE_READ);
   if (handle < 0) return(-1);
   int ArrayCount = FileSize(handle) / 1936;
   ArrayResize(sSymbols, ArrayCount);
   for(int iCount = 0; iCount < ArrayCount; iCount++)
   {
      sSymbols[iCount] = FileReadString(handle, 12);
      FileSeek(handle, 1924, SEEK_CUR);
   }
   FileClose(handle);
   return(ArrayCount);
}
//+------------------------------------------------------------------+